import os

from jnpr.junos import Device
from lxml import etree

from inventory_provider import config


def _load_netconf(hostname, ssh_params):

    dev = Device(
        host=hostname,
        user=ssh_params['username'],
        ssh_private_key_file=ssh_params['private-key'])
    dev.open()
    print(dev.facts)
    return dev.rpc.get_config()

    # print(etree.tostring(data, encoding='unicode'))
    #
    # # for i in data.xpath('//configuration/groups/interfaces/interface'):
    # for i in data.xpath('//configuration/interfaces/interface'):
    #     # print(i)
    #     print(i.xpath('./name/text()'))
    #
    # print("-----routing-instances-----")
    # for i in data.xpath("//configuration/routing-instances/instance/interface"):
    #     print(i.xpath('./name/text()'))
    #

if __name__ == "__main__":

    TEST_DATA_DIR = os.path.dirname(__file__)
    CONFIG_FILENAME = "config.json"

    with open("config.json") as f:
        params = config.load(f)
    for r in params['routers']:
        netconf = _load_netconf(r['hostname'], params['ssh'])
        filename = os.path.join(
            TEST_DATA_DIR,
            "%s-netconf.xml" % r['hostname'])
        with open(filename, 'w') as f:
            f.write(etree.tostring(netconf, encoding='unicode'))
